# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]

### Breaking

-   You will need to add an ISO 2 `lang` value in your configuration in order to keep generating a manifest file without issues.

### Added

-   Support for the keys `dir`, `lang`, `prefer_related_applications` and `related_applications` in the manifest: they are now configurable and will be outputed in the `manifest.json` file.

### Fixed

-   The names of the different options in the API section of the README have been updated to reflect the changes in the version `0.2.0`.
-   The manifest file will now be served with the MIME type `application/manifest+json` instead of `application/json` to respect the standard.

## [0.2.1] - 2019-12-26

### Fixed

-   The documentation example showing the necessary keys to add to the `options` key of the plugin have been updated to follow one of the fix that the version `0.2.0` provided.

## [0.2.0] - 2019-12-26

### Added

-   A `<meta name="theme-color" />` will be automatically added to the head of your html files (using the `theme_color` value you provided in the options in the file `gridsome.client.js`).

### Fixed

-   The default `display` option in the manifest will now be `minimal-ui` (instead of `browser`) to fix a bug when Lighthouse was not recognizing the `browser` display value.
-   The `manifest.json` file will be correctly formed (previously, pascal cased keys were used, now this file is generated using correct snake cased keys).

## [0.1.1] - 2019-12-25

### Fixed

-   Bug when the `fileName` option was forbidden instead of being allowed.

## [0.1.0] - 2019-12-25

### Added

-   First working version
